#include "main.h"
#include "Bfont.h"

extern int ships,
    current_music,
    repeat_music,
    cannon_ammo,
    missiles,
    score,
    weapon,
    size,
    num_explos,
    current_level,
    t2,
    game_finished,
    help,
    credits,
    credits_pos;

extern struct object ship;

extern SDL_Rect epos,esrc,spos,ssrc;

extern SDL_Surface *screen,*energy,*shield;
extern BFont_Info *font;
extern char *tracks[];
extern char message[64];
extern int message_time;

char *weapons[] = {"Cannon","Rockets"};

extern float fps;

void Show_HUD()
{
    if(!credits)
    {
	if(!repeat_music)
	    RightPrintStringFont  (screen, font, screen->h-FontHeight(font)*2, "Track %d | Energy: %d",current_music+1,ship.energy);
	else
	    RightPrintStringFont  (screen, font, screen->h-FontHeight(font)*2, "Repeat | Track %d | Energy: %d",current_music+1,ship.energy);
	RightPrintStringFont  (screen, font, screen->h-FontHeight(font), "%s",tracks[current_music*2]);

	//title
	CenteredPrintStringFont  (screen, font, 0, "SDL-FighterX for XBOX");
	//level
	RightPrintStringFont  (screen,font,FontHeight(font),"Level: %d/%d | %.1f",current_level,NUM_LEVELS,fps);

	if(t2 - message_time < MESSAGE_TIMEOUT && message != NULL)
	    LeftPrintStringFont  (screen,font,FontHeight(font),"%s",message);

	//message
	if(!ships && !help) {
#ifdef _XBOX
	    CenteredPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font), "You are dead");
#else
	    CenteredPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font), "You are dead %s",cuserid(NULL));
#endif
	    CenteredPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 , "Hit A to restart");
	    CenteredPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font), "or BLACK/BACK to exit");
	}

	if(game_finished && !help) {
	    CenteredPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)*2, "Game over!");
#ifdef _XBOX
	    CenteredPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font), "You win!");
#else
	    CenteredPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font), "You win %s!",cuserid(NULL));
#endif
	    CenteredPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 , "Hit A to restart");
	    CenteredPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font), "or BLACK/BACK to exit");
	}

	if(help && !credits) {
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)*5 ,"F1");
	    RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)*5 ,"toggle fullscreen");	
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)*4 ,"BACK-Button");
	    RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)*4 ,"help");
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)*3 ,"BLACK-Button");
            RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)*3 ,"credits");
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)*2 ,"START-Button");
	    RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)*2 ,"pause game");
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)   ,"X-Button/Y-Button");
	    RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 - FontHeight(font)   ,"music volume");
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2		       ,"u/l");
	    RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2		       ,"SFX volume");
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font)   ,"L-Button/R-Button/Right thumbstick");
	    RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font)   ,"previous music/next music/pause music");
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font)*2 ,"DPAD/Analogue stick");
	    RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font)*2 ,"move");
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font)*3 ,"B-Button");
	    RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font)*3 ,"change weapon");
	    LeftPrintStringFont   (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font)*4 ,"A-Button");
	    RightPrintStringFont  (screen, font, screen->h/2 - FontHeight(font)/2 + FontHeight(font)*4 ,"fire");
	}

	ssrc.y = 0;
	ssrc.x = 0;
	ssrc.w = shield->w;
	ssrc.h = ship.shield;
	spos.y = screen->h - shield->h - FontHeight(font)*2 + (100 - ship.shield);
	SDL_BlitSurface(shield,&ssrc,screen,&spos); //show player ship shield

	esrc.y = 0;
	esrc.x = 0;
	esrc.w = energy->w;
	esrc.h = ship.energy;
	epos.y = screen->h - energy->h - FontHeight(font)*2 + (100 - ship.energy);
	SDL_BlitSurface(energy,&esrc,screen,&epos); //show player ship energy

	PrintStringFont  (screen, font, 0, screen->h-FontHeight(font)*2, "Shield: %d | Weapon: %s",ship.shield, (ship.weapon == CANNON) ? weapons[0] : weapons[1]);
	PrintStringFont  (screen, font, 0, screen->h-FontHeight(font), "Score: %d | Ships: %d | Ammo: %d",score, ships, (ship.weapon == CANNON) ? cannon_ammo : missiles);      
    } else {
	CenteredPrintStringFont  (screen, font, credits_pos                      , "SDL-FighterX");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*2 , "Main code and images");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*3 , "Radoslaw Gniazdowski");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*5 , "BFont library");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*6 , "Diego Billi");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*8 , "Beta tester and win32 makefile");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*9 , "Mariusz Gniazdowski");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*11 , "Music");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*12 , "Mantronix - Phenomena Enigma");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*13 , "Mekkannik/Btl - 10 Minutes Trash");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*14 , "Moby - Dragonsfunk and Knulla Kuk");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*16 , "XBOX port by freakdave");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*18 , "Greetings go to:");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*19 , "Lantus,Xantium,Reaper527,dracflamloc");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*20 , "JapanFred and the whole XBOX-Scene Community!");
	CenteredPrintStringFont  (screen, font, credits_pos + FontHeight(font)*22 , "visit http://freakdave.xbox-scene.com");

    }
}
