#include <SDL.h>
#include <SDL_mixer.h>
#include <SDL_image.h>
#include <stdio.h>
#include <stdlib.h>
//#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>

struct object{
    int type;
    int remove;
    SDL_Surface *image;
    SDL_Rect rect;
    float velocity;
    int weapon;
    int tols;
    int energy;
    int shield;
    int direction; // kierunek 0 w lewo | 1 w prawo | 2 prosto
    void (*MoveOBJ)(struct object *obj);
};



struct explosion{
    SDL_Rect rect;
    int startx;
    int starty;
    int tolfc; //time of last frame change
    int frame;
    int ttw;
};

#define MESSAGE_TIMEOUT 1800	

#define NUM_BOOM_FRAMES	31
#define NUM_LEVELS	5
#define NUM_TRACKS	7
#define NUM_CHUNKS	4	
#define NUM_IMAGES	13	

#define EN_SIZE sizeof(struct object)
#define EX_SIZE sizeof(struct explosion)

#define	BULLET		0
#define MISSILE		1
#define SHIP_BULLET	2
#define SHIP_MISSILE	3
#define ENEMY		4
#define PACK_LIVE	5
#define PACK_ENERGY	6
#define PACK_SHIELD	7
#define PACK_SURPRISE   8 
#define CANNON		9	
#define ROCKET		10
#define BOSS		11

#ifdef _XBOX
#define main_dir "d:\\"
#define pixmaps_dir "d:\\pixmaps\\"
#define sounds_dir "d:\\sounds\\"
#define explosion_dir "d:\\pixmaps\\explosion\\"
#else
#define main_dir "/usr/local/games/SDLFighter/"
#define sounds_dir main_dir"sounds/"
#define pixmaps_dir main_dir"pixmaps/"
#define explosion_dir main_dir"pixmaps/explosion/"
#endif

void AddOBJ(int x,int y,int type);
void AddExplosion(int x,int y);

void DeleteOBJ(int which);
void DeleteExplosion(int which);

int Collide(struct object *obj_a, struct object *obj_b);
void CheckEnemyCollisions(int index);
void CheckShipCollisions();
void CheckScreenEdges(int index);

void DrawOBJ(struct object obj);
void DrawExplosions();

void MoveDown(struct object *obj);
void MoveUp(struct object *obj);

void MoveRandomDown(struct object *obj);
void MoveRandomUp(struct object *obj);

int rand_ab(int a, int b);

void LoadFrames();

SDL_Surface *LoadImage(char *filename);
void SetBGAlpha(SDL_Surface *img);

void CheckSurface(SDL_Surface *img, const char *fmt, ...);
void error_exit(const char *fmt, ...);
void Show_HUD();

void AddMessage(const char *fmt, ...);
void write_log(const char *fmt, ...);
void NextMUS();
void NewGame();
void load_settings();

