#include "main.h"

extern int message_time,
    size,
    quit,
    repeat_music,
    current_music,
    game_finished,
    num_scrolls,
    music_volume;

extern char message[64];

extern struct object objects[64];
extern struct explosion explosions[24];
extern struct object ship;

extern Mix_Music *music[NUM_TRACKS];

void AddMessage(const char *fmt, ...)
{
    char buff[64];
    va_list args;

    va_start(args,fmt);
    vsprintf(buff,fmt,args);
    va_end(args);

    message_time = SDL_GetTicks();
    sprintf(message,"%s",buff);
}

void write_log(const char *fmt, ...)
{
    char buff[256];
    FILE *log;
    va_list args;

    va_start(args,fmt);
    vsprintf(buff,fmt,args);
    va_end(args);

    if((log = fopen(main_dir"log.log","a")) == NULL)
    {
        printf("Unable to open log\n");
        return;
    }

    fprintf(log,"%s\n",buff);
    fclose(log);
}
void error_exit(const char *fmt, ...)
{
    char buff[256];
    int i;
    va_list args;

    va_start(args,fmt);
    vsprintf(buff,fmt,args);
    va_end(args);

    printf("%s\n",buff);

    for(i=0;i<NUM_TRACKS;i++)
        if(music[i] != NULL) Mix_FreeMusic(music[i]);

    SDL_Quit();
    exit(0);
}
//check surface
void CheckSurface(SDL_Surface *img, const char *fmt, ...)
{
    char buff[256];
    va_list args;

    va_start(args,fmt);
    vsprintf(buff,fmt,args);
    va_end(args);

    if(img == NULL) {
        write_log("*** ERROR *** %s");
        write_log("Closing session with error\n");
        printf("*** ERROR *** %s\n",buff);

        SDL_Quit();
        exit(0);
    }
}
void NewGame() //new game
{
    int i;

    for(i=0;i<size;i++)
    {
        objects[i].energy = 0;
    }
    num_scrolls = 0;
    ship.energy = 0;
    ship.shield = 0;
    game_finished = 0;
}

void NextMUS()
{
    if(quit == 0 && repeat_music == 0)
    {
        current_music++;

        if(current_music == NUM_TRACKS)
            current_music = 0;

        Mix_PlayMusic(music[current_music],1);
	
    }

    if(quit == 0 && repeat_music)
        Mix_PlayMusic(music[current_music],1);

    Mix_VolumeMusic(music_volume);
}
